/*! DSFR v1.9.2 | SPDX-License-Identifier: MIT | License-Filename: LICENSE.md | restricted use (see terms and conditions) */
const e=new class{constructor(){this.modules={}}create(e){const t=new e;this.modules[t.type]=t}getModule(e){return this.modules[e]}add(e,t){this.modules[e].add(t)}remove(e,t){this.modules[e].remove(t)}get isActive(){return this._isActive}set isActive(e){if(e===this._isActive)return;this._isActive=e;const t=Object.keys(this.modules).map((e=>this.modules[e]));if(e)for(const e of t)e.activate();else for(const e of t)e.deactivate()}get isLegacy(){return this._isLegacy}set isLegacy(e){e!==this._isLegacy&&(this._isLegacy=e)}},t="fr",s="dsfr",i="@gouvfr",n="1.9.2";class r{constructor(e,t,s,i){switch(this.level=e,this.light=t,this.dark=s,i){case"warn":this.logger=console.warn;break;case"error":this.logger=console.error;break;default:this.logger=console.log}}log(...e){const t=new o(s);for(const s of e)t.add(s);this.print(t)}print(e){e.setColor(this.color),this.logger.apply(console,e.getMessage())}get color(){return window.matchMedia("(prefers-color-scheme: dark)").matches?this.dark:this.light}}class o{constructor(e){this.inputs=["%c"],this.styles=["font-family:Marianne","line-height: 1.5"],this.objects=[],e&&this.add(`${e} :`)}add(e){switch(typeof e){case"object":case"function":this.inputs.push("%o "),this.objects.push(e);break;default:this.inputs.push(`${e} `)}}setColor(e){this.styles.push(`color:${e}`)}getMessage(){return[this.inputs.join(""),this.styles.join(";"),...this.objects]}}const a={log:new r(0,"#616161","#989898"),debug:new r(1,"#000091","#8B8BFF"),info:new r(2,"#007c3b","#00ed70"),warn:new r(3,"#ba4500","#fa5c00","warn"),error:new r(4,"#D80600","#FF4641","error")};const c=new class{constructor(){this.level=2;for(const e in a){const t=a[e];this[e]=(...e)=>{this.level<=t.level&&t.log.apply(t,e)},this[e].print=t.print.bind(t)}}state(){const t=new o;t.add(e),this.log.print(t)}tree(){const t=e.getModule("stage");if(!t)return;const s=new o;this._branch(t.root,0,s),this.log.print(s)}_branch(e,t,s){let i="";if(t>0){let e="";for(let s=0;s<t;s++)e+="    ";i+=e+"└─ "}i+=`[${e.id}] ${e.html}`,s.add(i),s.add({"@":e}),s.add("\n");for(const n of e.children)i+=this._branch(n,t+1,s)}},h=e=>{"loading"!==document.readyState?window.requestAnimationFrame(e):document.addEventListener("DOMContentLoaded",e)},l={AUTO:"auto",MANUAL:"manual",RUNTIME:"runtime",LOADED:"loaded",VUE:"vue",ANGULAR:"angular",REACT:"react"};const d=new class{constructor(){this._mode=l.AUTO,this.isStarted=!1,this.starting=this.start.bind(this),this.preventManipulation=!1}configure(e={},t,s){this.startCallback=t;const i=e.production&&(!s||"false"!==s.production);switch(!0){case s&&!isNaN(s.level):c.level=Number(s.level);break;case s&&s.verbose&&("true"===s.verbose||1===s.verbose):c.level=0;break;case i:c.level=999;break;case e.verbose:c.level=0}c.info(`version ${n}`),this.mode=e.mode||l.AUTO}set mode(e){switch(e){case l.AUTO:this.preventManipulation=!1,t=this.starting,h(t);break;case l.LOADED:this.preventManipulation=!1,h(this.starting);break;case l.RUNTIME:this.preventManipulation=!1,this.start();break;case l.MANUAL:this.preventManipulation=!1;break;case l.VUE:case l.ANGULAR:case l.REACT:this.preventManipulation=!0;break;default:return void c.error("Illegal mode")}var t;this._mode=e,c.info(`mode set to ${e}`)}get mode(){return this._mode}start(){c.info("start"),this.startCallback()}};class u{constructor(){this._collection=[]}forEach(e){this._collection.forEach(e)}map(e){return this._collection.map(e)}get length(){return this._collection.length}add(e){return!(this._collection.indexOf(e)>-1)&&(this._collection.push(e),this.onAdd&&this.onAdd(),this.onPopulate&&1===this._collection.length&&this.onPopulate(),!0)}remove(e){const t=this._collection.indexOf(e);if(-1===t)return!1;this._collection.splice(t,1),this.onRemove&&this.onRemove(),this.onEmpty&&0===this._collection.length&&this.onEmpty()}execute(...e){for(const t of this._collection)t&&t.apply(null,e)}clear(){this._collection.length=0}clone(){const e=new u;return e._collection=this._collection.slice(),e}get collection(){return this._collection}}class g extends u{constructor(e){super(),this.type=e,this.isActive=!1}activate(){}deactivate(){}}const p=e=>`${t}-${e}`;p.selector=(e,t)=>(void 0===t&&(t="."),`${t}${p(e)}`),(p.attr=e=>`data-${p(e)}`).selector=(e,t)=>{let s=p.attr(e);return void 0!==t&&(s+=`="${t}"`),`[${s}]`},p.event=e=>`${s}.${e}`,p.emission=(e,t)=>`emission:${e}.${t}`;const m=(e,t)=>Array.prototype.slice.call(e.querySelectorAll(t)),b=(e,t)=>{const s=e.parentElement;return s.matches(t)?s:s===document.documentElement?null:b(s,t)};class f{constructor(e,t,s){this.selector=e,this.InstanceClass=t,this.creator=s,this.instances=new u,this.isIntroduced=!1,this._instanceClassName=this.InstanceClass.instanceClassName,this._instanceClassNames=this.getInstanceClassNames(this.InstanceClass),this._property=this._instanceClassName.substring(0,1).toLowerCase()+this._instanceClassName.substring(1);const i=this._instanceClassName.replace(/[^a-zA-Z0-9]+/g,"-").replace(/([A-Z]+)([A-Z][a-z])/g,"$1-$2").replace(/([a-z])([A-Z])/g,"$1-$2").replace(/([0-9])([^0-9])/g,"$1-$2").replace(/([^0-9])([0-9])/g,"$1-$2").toLowerCase();this._attribute=p.attr(`js-${i}`)}getInstanceClassNames(e){const t=Object.getPrototypeOf(e);return t&&"Instance"!==t.instanceClassName?[...this.getInstanceClassNames(t),e.instanceClassName]:[e.instanceClassName]}hasInstanceClassName(e){return this._instanceClassNames.indexOf(e)>-1}introduce(){this.isIntroduced||(this.isIntroduced=!0,e.getModule("stage").parse(document.documentElement,this))}parse(e,t){const s=[];return e.matches&&e.matches(this.selector)&&s.push(e),!t&&e.querySelectorAll&&e.querySelector(this.selector)&&s.push.apply(s,m(e,this.selector)),s}create(e){if(!e.node.matches(this.selector))return;const t=new this.InstanceClass;return this.instances.add(t),t}remove(e){this.instances.remove(e)}dispose(){const e=this.instances.collection;for(let t=e.length-1;t>-1;t--)e[t]._dispose();this.creator=null}get instanceClassName(){return this._instanceClassName}get instanceClassNames(){return this._instanceClassNames}get property(){return this._property}get attribute(){return this._attribute}}class _ extends g{constructor(){super("register")}register(t,s,i){const n=new f(t,s,i);return this.add(n),e.isActive&&n.introduce(),n}activate(){for(const e of this.collection)e.introduce()}remove(e){e.dispose(),super.remove(e)}}let S=0;class E{constructor(e,t){t?this.id=t:(S++,this.id=S),this.node=e,this.attributeNames=[],this.instances=[],this._children=[],this._parent=null,this._projects=[]}get proxy(){const e=this;if(!this._proxy){this._proxy={id:this.id,get parent(){return e.parent?e.parent.proxy:null},get children(){return e.children.map((e=>e.proxy))}};for(const e of this.instances)this._proxy[e.registration.property]=e.proxy}return this._proxy}get html(){if(!this.node||!this.node.outerHTML)return"";const e=this.node.outerHTML.indexOf(">");return this.node.outerHTML.substring(0,e+1)}project(e){-1===this._projects.indexOf(e)&&this._projects.push(e)}populate(){const e=this._projects.slice();this._projects.length=0;for(const t of e)this.create(t)}create(e){if(this.hasInstance(e.instanceClassName))return;c.debug(`create instance of ${e.instanceClassName} on element [${this.id}]`);const t=e.create(this);this.instances.push(t),t._config(this,e),this._proxy&&(this._proxy[e.property]=t.proxy)}remove(e){const t=this.instances.indexOf(e);t>-1&&this.instances.splice(t,1),this._proxy&&delete this._proxy[e.registration.property]}get parent(){return this._parent}get ascendants(){return[this.parent,...this.parent.ascendants]}get children(){return this._children}get descendants(){const e=[...this._children];return this._children.forEach((t=>e.push(...t.descendants))),e}addChild(e,t){return this._children.indexOf(e)>-1?null:(e._parent=this,!isNaN(t)&&t>-1&&t<this._children.length?this._children.splice(t,0,e):this._children.push(e),e)}removeChild(e){const t=this._children.indexOf(e);if(-1===t)return null;e._parent=null,this._children.splice(t,1)}emit(t,s){const i=e.getModule("stage").collection,n=[];for(const e of i)n.push(...e._emit(t,s));return n}_emit(e,t){const s=[];for(const i of this.instances)s.push(...i._emitter.emit(e,t));return s}ascend(e,t){return this._parent?this._parent._ascend(e,t):[]}_ascend(e,t){const s=[];for(const i of this.instances)s.push(...i._ascent.emit(e,t));return this._parent&&s.push(...this._parent._ascend(e,t)),s}descend(e,t){const s=[];for(const i of this._children)s.push(...i._descend(e,t));return s}_descend(e,t){const s=[];for(const i of this.instances)s.push(...i._descent.emit(e,t));for(const i of this._children)s.push(...i._descend(e,t));return s}getInstance(e){for(const t of this.instances)if(t.registration.hasInstanceClassName(e))return t;return null}hasInstance(e){return null!==this.getInstance(e)}getDescendantInstances(e,t,s){if(!e)return[];const i=[];for(const n of this._children){const r=n.getInstance(e);r&&(i.push(r),s)||(t&&n.hasInstance(t)||!n.children.length||i.push.apply(i,n.getDescendantInstances(e,t,s)))}return i}getAscendantInstance(e,t){if(!e||!this._parent)return null;const s=this._parent.getInstance(e);return s||(t&&this._parent.hasInstance(t)?null:this._parent.getAscendantInstance(e,t))}dispose(){for(const e of this.instances)e._dispose();this.instances.length=0,e.remove("stage",this),this.parent.removeChild(this),this._children.length=0,c.debug(`remove element [${this.id}] ${this.html}`)}prepare(e){-1===this.attributeNames.indexOf(e)&&this.attributeNames.push(e)}examine(){const e=this.attributeNames.slice();this.attributeNames.length=0;for(let t=this.instances.length-1;t>-1;t--)this.instances[t].examine(e)}}class y extends E{constructor(){super(document.documentElement,"root"),this.node.setAttribute(p.attr("js"),!0)}}class v extends g{constructor(){super("stage"),this.root=new y,super.add(this.root),this.observer=new MutationObserver(this.mutate.bind(this)),this.modifications=[],this.willModify=!1,this.modifying=this.modify.bind(this)}hasElement(e){for(const t of this.collection)if(t.node===e)return!0;return!1}getElement(e){for(const t of this.collection)if(t.node===e)return t;const t=new E(e);return this.add(t),c.debug(`add element [${t.id}] ${t.html}`),t}getProxy(e){if(!this.hasElement(e))return null;return this.getElement(e).proxy}add(e){super.add(e),this.put(e,this.root)}put(e,t){let s=0;for(let i=t.children.length-1;i>-1;i--){const n=t.children[i],r=e.node.compareDocumentPosition(n.node);if(r&Node.DOCUMENT_POSITION_CONTAINS)return void this.put(e,n);if(r&Node.DOCUMENT_POSITION_CONTAINED_BY)t.removeChild(n),e.addChild(n,0);else if(r&Node.DOCUMENT_POSITION_PRECEDING){s=i+1;break}}t.addChild(e,s)}activate(){this.observer.observe(document.documentElement,{childList:!0,subtree:!0,attributes:!0})}deactivate(){this.observer.disconnect()}mutate(e){const t=[];e.forEach((e=>{switch(e.type){case"childList":e.removedNodes.forEach((e=>this.dispose(e))),e.addedNodes.forEach((e=>this.parse(e)));break;case"attributes":if(this.hasElement(e.target)){const s=this.getElement(e.target);s.prepare(e.attributeName),-1===t.indexOf(s)&&t.push(s);for(const e of s.descendants)-1===t.indexOf(e)&&t.push(e)}-1===this.modifications.indexOf(e.target)&&this.modifications.push(e.target)}})),t.forEach((e=>e.examine())),this.modifications.length&&!this.willModify&&(this.willModify=!0,window.requestAnimationFrame(this.modifying))}modify(){this.willModify=!1;const e=this.modifications.slice();this.modifications.length=0;for(const t of e)document.documentElement.contains(t)&&this.parse(t)}dispose(e){const t=[];this.forEach((s=>{e.contains(s.node)&&t.push(s)}));for(const e of t)e.dispose(),this.remove(e)}parse(t,s,i){const n=s?[s]:e.getModule("register").collection,r=[];for(const e of n){const s=e.parse(t,i);for(const t of s){const s=this.getElement(t);s.project(e),-1===r.indexOf(s)&&r.push(s)}}for(const e of r)e.populate()}}class A extends g{constructor(){super("render"),this.rendering=this.render.bind(this),this.nexts=new u}activate(){window.requestAnimationFrame(this.rendering)}request(e){this.nexts.add(e)}render(){if(!e.isActive)return;if(window.requestAnimationFrame(this.rendering),this.forEach((e=>e.render())),!this.nexts.length)return;const t=this.nexts.clone();this.nexts.clear(),t.forEach((e=>e.next()))}}class C extends g{constructor(){super("resize"),this.requireResize=!1,this.resizing=this.resize.bind(this);const e=this.request.bind(this);document.fonts&&document.fonts.ready.then(e),window.addEventListener("resize",e),window.addEventListener("orientationchange",e)}activate(){this.request()}request(){this.requireResize||(this.requireResize=!0,window.requestAnimationFrame(this.resizing))}resize(){this.requireResize&&(this.forEach((e=>e.resize())),this.requireResize=!1)}}class T extends g{constructor(){super("lock"),this._isLocked=!1,this._scrollY=0,this.onPopulate=this.lock.bind(this),this.onEmpty=this.unlock.bind(this)}get isLocked(){return this._isLocked}lock(){this._isLocked||(this._isLocked=!0,this._scrollY=window.scrollY,this.isLegacy?document.body.style.top=-1*this._scrollY+"px":document.body.style.setProperty("--scroll-top",-1*this._scrollY+"px"),document.documentElement.setAttribute(p.attr("scrolling"),"false"))}unlock(){this._isLocked&&(this._isLocked=!1,document.documentElement.removeAttribute(p.attr("scrolling")),this.isLegacy?document.body.style.top="":document.body.style.removeProperty("--scroll-top"),window.scroll(0,this._scrollY))}}class L extends g{constructor(){super("load"),this.loading=this.load.bind(this)}activate(){window.addEventListener("load",this.loading)}load(){this.forEach((e=>e.load()))}}const N=["Marianne","Spectral"];class w extends g{constructor(){super("font-swap"),this.swapping=this.swap.bind(this)}activate(){document.fonts&&document.fonts.addEventListener("loadingdone",this.swapping)}swap(){const e=N.filter((e=>document.fonts.check(`16px ${e}`)));this.forEach((t=>t.swapFont(e)))}}class x extends g{constructor(){super("mouse-move"),this.requireMove=!1,this._isMoving=!1,this.moving=this.move.bind(this),this.requesting=this.request.bind(this),this.onPopulate=this.listen.bind(this),this.onEmpty=this.unlisten.bind(this)}listen(){this._isMoving||(this._isMoving=!0,this.requireMove=!1,document.documentElement.addEventListener("mousemove",this.requesting))}unlisten(){this._isMoving&&(this._isMoving=!1,this.requireMove=!1,document.documentElement.removeEventListener("mousemove",this.requesting))}request(e){this._isMoving&&(this.point={x:e.clientX,y:e.clientY},this.requireMove||(this.requireMove=!0,window.requestAnimationFrame(this.moving)))}move(){this.requireMove&&(this.forEach((e=>e.mouseMove(this.point))),this.requireMove=!1)}}const I=new class{constructor(){e.create(_),e.create(v),e.create(A),e.create(C),e.create(T),e.create(L),e.create(w),e.create(x);const t=e.getModule("register");this.register=t.register.bind(t)}get isActive(){return e.isActive}start(){c.debug("START"),e.isActive=!0}stop(){c.debug("STOP"),e.isActive=!1}};const O=e=>{switch(!0){case e.hover:return"-hover";case e.active:return"-active";default:return""}},D=new class{getColor(e,t,s,i={}){const n=`--${e}-${t}-${s}${O(i)}`;return getComputedStyle(document.documentElement).getPropertyValue(n).trim()||null}},M=e=>"."===e.charAt(0)?e.substr(1):e,k=e=>e.className?e.className.split(" "):[],R=(e,t,s)=>{t=M(t);const i=k(e),n=i.indexOf(t);!0===s?n>-1&&i.splice(n,1):-1===n&&i.push(t),e.className=i.join(" ")},P=(e,t)=>R(e,t),H=(e,t)=>R(e,t,!0),G=(e,t)=>k(e).indexOf(M(t))>-1,$=['[tabindex]:not([tabindex="-1"])',"a[href]","button:not([disabled])","input:not([disabled])","select:not([disabled])","textarea:not([disabled])","audio[controls]","video[controls]",'[contenteditable]:not([contenteditable="false"])',"details>summary:first-of-type","details","iframe"].join(),q=e=>e.querySelectorAll($),B={};B.addClass=P,B.hasClass=G,B.removeClass=H,B.queryParentSelector=b,B.querySelectorAllArray=m,B.queryActions=q;const U={supportLocalStorage:()=>{try{return"localStorage"in window&&null!==window.localStorage}catch(e){return!1}},supportAspectRatio:()=>!!window.CSS&&CSS.supports("aspect-ratio: 16 / 9")},z={NONE:p.selector("transition-none")},F={};F.TransitionSelector=z;const j=(e,...t)=>(t.forEach((t=>{const s=Object.keys(t).reduce(((e,s)=>(e[s]=Object.getOwnPropertyDescriptor(t,s),e)),{});Object.getOwnPropertySymbols(t).forEach((e=>{const i=Object.getOwnPropertyDescriptor(t,e);i.enumerable&&(s[e]=i)})),Object.defineProperties(e,s)})),e),W={};W.completeAssign=j;const K={},V={};Object.defineProperty(V,"isLegacy",{get:()=>e.isLegacy}),V.setLegacy=()=>{e.isLegacy=!0},K.legacy=V,K.dom=B,K.support=U,K.motion=F,K.property=W,K.ns=p,K.register=I.register,K.state=e,K.query=(e=>{if(e&&e.search){const e=new URLSearchParams(window.location.search).entries();return Object.fromEntries(e)}return null})(window.location),Object.defineProperty(K,"preventManipulation",{get:()=>d.preventManipulation}),Object.defineProperty(K,"stage",{get:()=>e.getModule("stage")});const Y=t=>e.getModule("stage").getProxy(t);Y.version=n,Y.prefix=t,Y.organisation=i,Y.Modes=l,Object.defineProperty(Y,"mode",{set:e=>{d.mode=e},get:()=>d.mode}),Y.internals=K,Y.version=n,Y.start=I.start,Y.stop=I.stop,Y.inspector=c,Y.colors=D;const Q=window[s];Y.internals.configuration=Q,d.configure(Q,Y.start,Y.internals.query),window[s]=Y;class J{constructor(){this.emissions={}}add(e,t){if("function"!=typeof t)throw new Error("closure must be a function");this.emissions[e]||(this.emissions[e]=[]),this.emissions[e].push(t)}remove(e,t){if(this.emissions[e])if(t){const s=this.emissions[e].indexOf(t);s>-1&&this.emissions[e].splice(s)}else delete this.emissions[e]}emit(e,t){if(!this.emissions[e])return[];const s=[];for(const i of this.emissions[e])i&&s.push(i(t));return s}dispose(){this.emissions=null}}class Z{constructor(e,t){this.id=e,this.minWidth=t}test(){return window.matchMedia(`(min-width: ${this.minWidth}em)`).matches}}const X={XS:new Z("xs",0),SM:new Z("sm",36),MD:new Z("md",48),LG:new Z("lg",62),XL:new Z("xl",78)};class ee{constructor(e=!0){this.jsAttribute=e,this._isRendering=!1,this._isResizing=!1,this._isScrollLocked=!1,this._isLoading=!1,this._isSwappingFont=!1,this._listeners={},this._keyListenerTypes=[],this._keys=[],this.handlingKey=this.handleKey.bind(this),this._emitter=new J,this._ascent=new J,this._descent=new J,this._registrations=[],this._nexts=[]}static get instanceClassName(){return"Instance"}_config(e,t){this.element=e,this.registration=t,this.node=e.node,this.id=e.node.id,this.jsAttribute&&this.setAttribute(t.attribute,!0),this.init()}init(){}get proxy(){const e=this;return j({render:()=>e.render(),resize:()=>e.resize()},{get node(){return this.node}})}register(t,s){const i=e.getModule("register").register(t,s,this);this._registrations.push(i)}getRegisteredInstances(e){for(const t of this._registrations)if(t.hasInstanceClassName(e))return t.instances.collection;return[]}dispatch(e,t,s,i){const n=new CustomEvent(e,{detail:t,bubble:!0===s,cancelable:!0===i});this.node.dispatchEvent(n)}listen(e,t,s){this._listeners[e]||(this._listeners[e]=[]),this._listeners[e].indexOf(t)>-1||(this._listeners[e].push(t),this.node.addEventListener(e,t,s))}unlisten(e,t){if(e)if(t){if(!this._listeners[e])return;const s=this._listeners[e].indexOf(t);s>-1&&this._listeners[e].splice(s,1),this.node.removeEventListener(e,t)}else{if(!this._listeners[e])return;for(const t of this._listeners[e])this.node.removeEventListener(e,t);this._listeners[e].length=0}else for(const e in this._listeners)this.unlisten(e)}listenKey(e,t,s=!1,i=!1,n="down"){-1===this._keyListenerTypes.indexOf(n)&&(this.listen(`key${n}`,this.handlingKey),this._keyListenerTypes.push(n)),this._keys.push(new te(n,e,t,s,i))}unlistenKey(e,t){this._keys=this._keys.filter((s=>s.code!==e||s.closure!==t)),this._keyListenerTypes.forEach((e=>{this._keys.some((t=>t.type===e))||this.unlisten(`key${e}`,this.handlingKey)}))}handleKey(e){for(const t of this._keys)t.handle(e)}get isRendering(){return this._isRendering}set isRendering(t){this._isRendering!==t&&(t?e.add("render",this):e.remove("render",this),this._isRendering=t)}render(){}request(t){this._nexts.push(t),e.getModule("render").request(this)}next(){const e=this._nexts.slice();this._nexts.length=0;for(const t of e)t&&t()}get isResizing(){return this._isResizing}set isResizing(t){this._isResizing!==t&&(t?(e.add("resize",this),this.resize()):e.remove("resize",this),this._isResizing=t)}resize(){}isBreakpoint(e){return!0==("string"==typeof e)?X[e.toUpperCase()].test():e.test()}get isScrollLocked(){return this._isScrollLocked}set isScrollLocked(t){this._isScrollLocked!==t&&(t?e.add("lock",this):e.remove("lock",this),this._isScrollLocked=t)}get isLoading(){return this._isLoading}set isLoading(t){this._isLoading!==t&&(t?e.add("load",this):e.remove("load",this),this._isLoading=t)}load(){}get isSwappingFont(){return this._isSwappingFont}set isSwappingFont(t){this._isSwappingFont!==t&&(t?e.add("font-swap",this):e.remove("font-swap",this),this._isSwappingFont=t)}swapFont(){}get isMouseMoving(){return this._isMouseMoving}set isMouseMoving(t){this._isMouseMoving!==t&&(t?e.add("mouse-move",this):e.remove("mouse-move",this),this._isMouseMoving=t)}mouseMove(e){}examine(e){this.node.matches(this.registration.selector)?this.mutate(e):this._dispose()}mutate(e){}_dispose(){c.debug(`dispose instance of ${this.registration.instanceClassName} on element [${this.element.id}]`),this.removeAttribute(this.registration.attribute),this.unlisten(),this._keys=null,this.isRendering=!1,this.isResizing=!1,this._nexts=null,e.getModule("render").nexts.remove(this),this.isScrollLocked=!1,this.isLoading=!1,this.isSwappingFont=!1,this._emitter.dispose(),this._emitter=null,this._ascent.dispose(),this._ascent=null,this._descent.dispose(),this._descent=null,this.element.remove(this);for(const t of this._registrations)e.remove("register",t);this._registrations=null,this.registration.remove(this),this.dispose()}dispose(){}emit(e,t){return this.element.emit(e,t)}addEmission(e,t){this._emitter.add(e,t)}removeEmission(e,t){this._emitter.remove(e,t)}ascend(e,t){return this.element.ascend(e,t)}addAscent(e,t){this._ascent.add(e,t)}removeAscent(e,t){this._ascent.remove(e,t)}descend(e,t){return this.element.descend(e,t)}addDescent(e,t){this._descent.add(e,t)}removeDescent(e,t){this._descent.remove(e,t)}get style(){return this.node.style}addClass(e){P(this.node,e)}removeClass(e){H(this.node,e)}hasClass(e){return G(this.node,e)}get classNames(){return k(this.node)}remove(){this.node.parentNode.removeChild(this.node)}setAttribute(e,t){this.node.setAttribute(e,t)}getAttribute(e){return this.node.getAttribute(e)}hasAttribute(e){return this.node.hasAttribute(e)}removeAttribute(e){this.node.removeAttribute(e)}setProperty(e,t){this.node.style.setProperty(e,t)}removeProperty(e){this.node.style.removeProperty(e)}focus(){this.node.focus()}focusClosest(){const e=this._focusClosest(this.node.parentNode);e&&e.focus()}_focusClosest(e){if(!e)return null;const t=[...q(e)];if(t.length<=1)return this._focusClosest(e.parentNode);{const e=t.indexOf(this.node);return t[e+(e<t.length-1?1:-1)]}}get hasFocus(){return this.node===document.activeElement}matches(e){return this.node.matches(e)}querySelector(e){return this.node.querySelector(e)}querySelectorAll(e){return m(this.node,e)}queryParentSelector(e){return b(this.node,e)}getRect(){return this.node.getBoundingClientRect()}get isLegacy(){return e.isLegacy}}class te{constructor(e,t,s,i,n){this.type=e,this.eventType=`key${e}`,this.code=t,this.closure=s,this.preventDefault=!0===i,this.stopPropagation=!0===n}handle(e){e.type===this.eventType&&e.keyCode===this.code&&(this.closure(e),this.preventDefault&&e.preventDefault(),this.stopPropagation&&e.stopPropagation())}}const se={DISCLOSE:p.event("disclose"),CONCEAL:p.event("conceal")},ie={RESET:p.emission("disclosure","reset"),ADDED:p.emission("disclosure","added"),REMOVED:p.emission("disclosure","removed"),GROUP:p.emission("disclosure","group"),UNGROUP:p.emission("disclosure","ungroup")};class ne extends ee{constructor(e,t,s,i){super(),this.type=e,this._selector=t,this.DisclosureButtonInstanceClass=s,this.disclosuresGroupInstanceClassName=i,this.modifier=this._selector+"--"+this.type.id,this.pristine=!0}static get instanceClassName(){return"Disclosure"}init(){this.addDescent(ie.RESET,this.reset.bind(this)),this.addDescent(ie.GROUP,this.update.bind(this)),this.addDescent(ie.UNGROUP,this.update.bind(this)),this.register(`[aria-controls="${this.id}"]`,this.DisclosureButtonInstanceClass),this.ascend(ie.ADDED),this.update()}get proxy(){const e=this,t=Object.assign(super.proxy,{disclose:e.disclose.bind(e),focus:e.focus.bind(e)});this.type.canConceal&&(t.conceal=e.conceal.bind(e));return j(t,{get buttons(){return e.buttons.map((e=>e.proxy))},get group(){const t=e.group;return t?t.proxy:null}})}get buttons(){return this.getRegisteredInstances(this.DisclosureButtonInstanceClass.instanceClassName)}update(){this.getGroup()}getGroup(){if(!this.disclosuresGroupInstanceClassName)return void(this._group=null);const e=this.element.getAscendantInstance(this.disclosuresGroupInstanceClassName,this.constructor.instanceClassName);e&&e.validate(this)?this._group=e:this._group=null}get group(){return this._group}disclose(e){return!this.disclosed&&(this.pristine=!1,this.disclosed=!0,!e&&this.group&&(this.group.current=this),!0)}conceal(e,t){return!!this.disclosed&&(!(!this.type.canConceal&&this.group&&this.group.current===this)&&(this.pristine=!1,this.disclosed=!1,!e&&this.group&&this.group.current===this&&(this.group.current=null),t||this.focus(),this.descend(ie.RESET),!0))}get disclosed(){return this._disclosed}set disclosed(e){if(this._disclosed!==e){this.dispatch(e?se.DISCLOSE:se.CONCEAL,this.type),this._disclosed=e,e?this.addClass(this.modifier):this.removeClass(this.modifier);for(let t=0;t<this.buttons.length;t++)this.buttons[t].apply(e)}}reset(){}toggle(e){if(this.type.canConceal)switch(!0){case!e:case this.disclosed:this.conceal();break;default:this.disclose()}else this.disclose()}get buttonHasFocus(){return!!this.buttons.some((e=>e.hasFocus))}get hasFocus(){return!!super.hasFocus||(!!this.buttonHasFocus||this.querySelectorAll(":focus").length>0)}focus(){for(let e=0;e<this.buttons.length;e++){const t=this.buttons[e];if(t.isPrimary)return void t.focus()}}dispose(){this._group=null,super.dispose(),this.ascend(ie.REMOVED)}}class re extends ee{constructor(e){super(),this.type=e,this.attributeName=e.ariaState?"aria-"+e.id:p.attr(e.id)}static get instanceClassName(){return"DisclosureButton"}init(){this.controlsId=this.getAttribute("aria-controls"),this.isPrimary=this.hasAttribute(this.attributeName),this.isPrimary&&this.disclosed&&this.registration.creator.pristine&&this.registration.creator.disclose(),this.listen("click",this.click.bind(this))}get proxy(){return Object.assign(super.proxy,{focus:this.focus.bind(this)})}click(e){this.registration.creator&&this.registration.creator.toggle(this.isPrimary)}mutate(e){this.isPrimary&&e.indexOf(this.attributeName)>-1&&this.registration.creator&&(this.disclosed?this.registration.creator.disclose():this.type.canConceal&&this.registration.creator.conceal())}apply(e){this.isPrimary&&this.setAttribute(this.attributeName,e)}get disclosed(){return"true"===this.getAttribute(this.attributeName)}}class oe extends ee{constructor(e,t){super(t),this.disclosureInstanceClassName=e,this._index=-1}static get instanceClassName(){return"DisclosuresGroup"}init(){this.addAscent(ie.ADDED,this.update.bind(this)),this.addAscent(ie.REMOVED,this.update.bind(this)),this.descend(ie.GROUP),this.update()}get proxy(){const e=this,t={set index(t){e.index=t},get index(){return e.index},get length(){return e.length},get current(){const t=e.current;return t?t.proxy:null},get members(){return e.members.map((e=>e.proxy))},get hasFocus(){return e.hasFocus}};return j(super.proxy,t)}validate(e){return!0}getMembers(){const e=this.element.getDescendantInstances(this.disclosureInstanceClassName,this.constructor.instanceClassName,!0);this._members=e.filter(this.validate.bind(this))}update(){this.getMembers(),this.getIndex()}get members(){return this._members}get length(){return this.members?this.members.length:0}getIndex(){this._index=-1;for(let e=0;e<this.length;e++)this.index>-1?this.members[e].conceal(!0,!0):this.members[e].disclosed&&(this.index=e)}get index(){return this._index}set index(e){if(!(e<-1||e>=this.length||e===this._index)){this._index=e;for(let t=0;t<this.length;t++){const s=this.members[t];e===t?s.disclose(!0):s.conceal(!0,!0)}this.apply()}}get current(){return-1===this._index?null:this.members[this._index]}set current(e){this.index=this.members.indexOf(e)}get hasFocus(){const e=this.current;return!!e&&e.hasFocus}apply(){}dispose(){super.dispose(),this.descend(ie.UNGROUP),this._members=null}}const ae={EXPAND:{id:"expanded",ariaState:!0,ariaControls:!0,canConceal:!0},SELECT:{id:"selected",ariaState:!0,ariaControls:!0,canConceal:!1},OPENED:{id:"opened",ariaState:!1,ariaControls:!0,canConceal:!0}},ce={PREVENT_CONCEAL:p.attr.selector("prevent-conceal")};class he extends re{constructor(){super(ae.EXPAND)}static get instanceClassName(){return"CollapseButton"}}const le={COLLAPSE:p.selector("collapse"),COLLAPSING:p.selector("collapsing")};const de={CHANGE:p("equisized")};const ue={TOGGLE:p.event("toggle")};const ge={INJECT_SVG:`[${p.attr("inject-svg")}]`};const pe={ARTWORK_USE:`${p.selector("artwork")} use`},me=["32x9","16x9","3x2","4x3","1x1","3x4","2x3"],be=(e,t)=>t.map((t=>p.selector(`${e}--${t}`))).join(","),fe=`${p.selector("responsive-img")}, ${be("responsive-img",me)}, ${p.selector("responsive-vid")}, ${be("responsive-vid",["16x9","4x3","1x1"])}`,_e={RATIO:`${p.selector("ratio")}, ${be("ratio",me)}, ${fe}`},Se=window[s];Y.core={Instance:ee,Breakpoints:X,KeyCodes:{TAB:9,ESCAPE:27,END:35,HOME:36,LEFT:37,UP:38,RIGHT:39,DOWN:40},Disclosure:ne,DisclosureButton:re,DisclosuresGroup:oe,DisclosureType:ae,DisclosureEvent:se,DisclosureSelector:ce,DisclosureEmission:ie,Collapse:class extends ne{constructor(){super(ae.EXPAND,le.COLLAPSE,he,"CollapsesGroup")}static get instanceClassName(){return"Collapse"}init(){super.init(),this.listen("transitionend",this.transitionend.bind(this))}transitionend(e){this.removeClass(le.COLLAPSING),this.disclosed||(this.isLegacy?this.style.maxHeight="":this.style.removeProperty("--collapse-max-height"))}unbound(){this.isLegacy?this.style.maxHeight="none":this.style.setProperty("--collapse-max-height","none")}disclose(e){this.disclosed||(this.unbound(),this.request((()=>{this.addClass(le.COLLAPSING),this.adjust(),this.request((()=>{super.disclose(e)}))})))}conceal(e,t){this.disclosed&&this.request((()=>{this.addClass(le.COLLAPSING),this.adjust(),this.request((()=>{super.conceal(e,t)}))}))}adjust(){this.setProperty("--collapser","none");const e=this.node.offsetHeight;this.setProperty("--collapse",-e+"px"),this.setProperty("--collapser","")}reset(){this.pristine||(this.disclosed=!1)}},CollapseButton:he,CollapsesGroup:class extends oe{constructor(){super("Collapse")}static get instanceClassName(){return"CollapsesGroup"}},CollapseSelector:le,RootSelector:{ROOT:":root"},Equisized:class extends ee{static get instanceClassName(){return"Equisized"}init(){this.ascend(de.CHANGE)}measure(){return this.isLegacy&&(this.style.width="auto"),this.getRect().width}adjust(e){this.isLegacy&&(this.style.width=`${e}px`)}dispose(){this.ascend(de.CHANGE)}},EquisizedEmission:de,Toggle:class extends ee{static get instanceClassName(){return"Toggle"}init(){this.pressed="true"===this.pressed,this.listen("click",this.toggle.bind(this))}toggle(){this.pressed="true"!==this.pressed}get pressed(){return this.getAttribute("aria-pressed")}set pressed(e){this.setAttribute("aria-pressed",e?"true":"false"),this.dispatch(ue.TOGGLE,e)}get proxy(){const e=this,t=Object.assign(super.proxy,{toggle:e.toggle.bind(e)});return j(t,{get pressed(){return e.pressed},set pressed(t){e.pressed=t}})}},EquisizedsGroup:class extends ee{static get instanceClassName(){return"EquisizedsGroup"}init(){this.isResizing=!0,this.isLoading=!0,this.addAscent(de.CHANGE,this.resize.bind(this))}load(){this.resize()}resize(){const e=this.element.getDescendantInstances("Equisized");this.isLegacy||this.style.setProperty("--equisized-width","auto");const t=Math.max(...e.map((e=>e.measure())));this.isLegacy?e.forEach((e=>e.adjust(t))):this.style.setProperty("--equisized-width",`${t}px`)}},InjectSvg:class extends ee{static get instanceClassName(){return"InjectSvg"}init(){this.node&&(this.img=this.node.querySelector("img")),this.isLegacy||this.replace()}get proxy(){const e=this;return Object.assign(super.proxy,{replace:e.replace.bind(e),restore:e.restore.bind(e)})}fetch(){this.img&&(this.imgID=this.img.getAttribute("id"),this.imgClass=this.img.getAttribute("class"),this.imgURL=this.img.getAttribute("src"),fetch(this.imgURL).then((e=>e.text())).then((e=>{const t=(new DOMParser).parseFromString(e,"text/html");this.svg=t.querySelector("svg"),this.svg&&this.replace()})))}replace(){if(!this.svg)return void this.fetch();this.imgID&&void 0!==this.imgID&&this.svg.setAttribute("id",this.imgID);let e=this.imgURL.match(/[ \w-]+\./)[0];e&&(e=e.slice(0,-1),["dark","light","system"].includes(e)&&(this.svg.innerHTML=this.svg.innerHTML.replaceAll('id="artwork-',`id="${e}-artwork-`),this.svg.innerHTML=this.svg.innerHTML.replaceAll('"#artwork-',`"#${e}-artwork-`))),this.imgClass&&void 0!==this.imgClass&&this.svg.setAttribute("class",this.imgClass),this.svg.hasAttribute("xmlns:a")&&this.svg.removeAttribute("xmlns:a"),this.node.setAttribute("data-fr-inject-svg",!0);var t,s;t=this.svg,s={"aria-hidden":!0,focusable:!1},Object.keys(s).forEach((e=>t.setAttribute(e,s[e]))),this.node.replaceChild(this.svg,this.img)}restore(){this.img&&this.svg&&(this.node.setAttribute("data-fr-inject-svg",!1),this.node.replaceChild(this.img,this.svg))}},InjectSvgSelector:ge,Artwork:class extends ee{static get instanceClassName(){return"Artwork"}init(){this.isLegacy&&this.replace()}get proxy(){return Object.assign(super.proxy,{replace:this.replace.bind(this)})}fetch(){this.xlink=this.node.getAttribute("href");const e=this.xlink.split("#");this.svgUrl=e[0],this.svgName=e[1];const t=new XMLHttpRequest;t.onload=()=>{const e=(new DOMParser).parseFromString(t.responseText,"text/html");this.realSvgContent=e.getElementById(this.svgName),this.realSvgContent&&(this.realSvgContent.classList.add(this.node.classList),this.replace())},t.open("GET",this.svgUrl),t.send()}replace(){this.realSvgContent?this.node.parentNode.replaceChild(this.realSvgContent,this.node):this.fetch()}},ArtworkSelector:pe,Ratio:class extends ee{static get instanceClassName(){return"Ratio"}init(){if(!Se.internals.support.supportAspectRatio()){this.ratio=16/9;for(const e in this.classNames)if(this.registration.selector.indexOf(this.classNames[e])>0){const t=this.classNames[e].split("ratio-");t[1]&&(this.ratio=t[1].split("x")[0]/t[1].split("x")[1])}this.isRendering=!0,this.update()}}render(){this.getRect().width!==this.currentWidth&&this.update()}update(){this.currentWidth=this.getRect().width,this.style.height=this.currentWidth/this.ratio+"px"}},RatioSelector:_e},Y.internals.register(Y.core.CollapseSelector.COLLAPSE,Y.core.Collapse),Y.internals.register(Y.core.InjectSvgSelector.INJECT_SVG,Y.core.InjectSvg),Y.internals.register(Y.core.RatioSelector.RATIO,Y.core.Ratio);const Ee={SYSTEM:"system",LIGHT:"light",DARK:"dark"},ye={THEME:Se.internals.ns.attr("theme"),SCHEME:Se.internals.ns.attr("scheme"),TRANSITION:Se.internals.ns.attr("transition")},ve={LIGHT:"light",DARK:"dark"},Ae={SCHEME:Se.internals.ns.emission("scheme","scheme"),THEME:Se.internals.ns.emission("scheme","theme"),ASK:Se.internals.ns.emission("scheme","ask")},Ce={SCHEME:Se.internals.ns.event("scheme"),THEME:Se.internals.ns.event("theme")};class Te extends Se.core.Instance{constructor(){super(!1)}static get instanceClassName(){return"Scheme"}init(){this.changing=this.change.bind(this),this.hasAttribute(ye.TRANSITION)&&(this.removeAttribute(ye.TRANSITION),this.request(this.restoreTransition.bind(this)));const e=Se.internals.support.supportLocalStorage()?localStorage.getItem("scheme"):"",t=this.getAttribute(ye.SCHEME);switch(e){case Ee.DARK:case Ee.LIGHT:case Ee.SYSTEM:this.scheme=e;break;default:switch(t){case Ee.DARK:this.scheme=Ee.DARK;break;case Ee.LIGHT:this.scheme=Ee.LIGHT;break;default:this.scheme=Ee.SYSTEM}}this.addAscent(Ae.ASK,this.ask.bind(this)),this.addAscent(Ae.SCHEME,this.apply.bind(this))}get proxy(){const e=this,t={get scheme(){return e.scheme},set scheme(t){e.scheme=t}};return Se.internals.property.completeAssign(super.proxy,t)}restoreTransition(){this.setAttribute(ye.TRANSITION,"")}ask(){this.descend(Ae.SCHEME,this.scheme)}apply(e){this.scheme=e}get scheme(){return this._scheme}set scheme(e){if(this._scheme!==e){switch(this._scheme=e,e){case Ee.SYSTEM:this.listenPreferences();break;case Ee.DARK:this.unlistenPreferences(),this.theme=ve.DARK;break;case Ee.LIGHT:this.unlistenPreferences(),this.theme=ve.LIGHT;break;default:return void(this.scheme=Ee.SYSTEM)}this.descend(Ae.SCHEME,e),Se.internals.support.supportLocalStorage()&&localStorage.setItem("scheme",e),this.setAttribute(ye.SCHEME,e),this.dispatch(Ce.SCHEME,{scheme:this._scheme})}}get theme(){return this._theme}set theme(e){if(this._theme!==e)switch(e){case ve.LIGHT:case ve.DARK:this._theme=e,this.setAttribute(ye.THEME,e),this.descend(Ae.THEME,e),this.dispatch(Ce.THEME,{theme:this._theme}),document.documentElement.style.colorScheme=e===ve.DARK?"dark":""}}listenPreferences(){this.isListening||(this.isListening=!0,this.mediaQuery=window.matchMedia("(prefers-color-scheme: dark)"),this.mediaQuery.addEventListener("change",this.changing),this.change())}unlistenPreferences(){this.isListening&&(this.isListening=!1,this.mediaQuery.removeEventListener("change",this.changing),this.mediaQuery=null)}change(){this.isListening&&(this.theme=this.mediaQuery.matches?ve.DARK:ve.LIGHT)}mutate(e){e.indexOf(ye.SCHEME)>-1&&(this.scheme=this.getAttribute(ye.SCHEME)),e.indexOf(ye.THEME)>-1&&(this.theme=this.getAttribute(ye.THEME))}dispose(){this.unlistenPreferences()}}const Le={SCHEME:`:root${Se.internals.ns.attr.selector("theme")}, :root${Se.internals.ns.attr.selector("scheme")}`,SWITCH_THEME:Se.internals.ns.selector("switch-theme"),RADIO_BUTTONS:`input[name="${Se.internals.ns("radios-theme")}"]`};Se.scheme={Scheme:Te,SchemeValue:Ee,SchemeSelector:Le,SchemeEmission:Ae,SchemeTheme:ve,SchemeEvent:Ce},Se.internals.register(Se.scheme.SchemeSelector.SCHEME,Se.scheme.Scheme);const Ne={GROUP:Se.internals.ns.selector("accordions-group"),COLLAPSE:`${Se.internals.ns.selector("accordion")} > ${Se.internals.ns.selector("collapse")}`};class we extends Se.core.CollapsesGroup{static get instanceClassName(){return"AccordionsGroup"}validate(e){return e.node.matches(Ne.COLLAPSE)}}Se.accordion={AccordionSelector:Ne,AccordionsGroup:we},Se.internals.register(Se.accordion.AccordionSelector.GROUP,Se.accordion.AccordionsGroup);const xe={EQUISIZED_BUTTON:`${Se.internals.ns.selector("btns-group--equisized")} ${Se.internals.ns.selector("btn")}`,EQUISIZED_GROUP:Se.internals.ns.selector("btns-group--equisized")};Se.button={ButtonSelector:xe},Se.internals.register(Se.button.ButtonSelector.EQUISIZED_BUTTON,Se.core.Equisized),Se.internals.register(Se.button.ButtonSelector.EQUISIZED_GROUP,Se.core.EquisizedsGroup);class Ie extends Se.core.Instance{constructor(){super(),this.count=0,this.focusing=this.focus.bind(this)}static get instanceClassName(){return"Breadcrumb"}init(){this.getCollapse(),this.isResizing=!0}get proxy(){const e=this;return Object.assign(super.proxy,{focus:e.focus.bind(e),disclose:e.collapse.disclose.bind(e.collapse)})}getCollapse(){const e=this.collapse;e?e.listen(Se.core.DisclosureEvent.DISCLOSE,this.focusing):this.addAscent(Se.core.DisclosureEmission.ADDED,this.getCollapse.bind(this))}resize(){const e=this.collapse,t=this.links;e&&t.length&&(this.isBreakpoint(Se.core.Breakpoints.MD)?e.buttonHasFocus&&t[0].focus():t.indexOf(document.activeElement)>-1&&e.focus())}get links(){return[...this.querySelectorAll("a[href]")]}get collapse(){return this.element.getDescendantInstances(Se.core.Collapse.instanceClassName,null,!0)[0]}focus(){this.count=0,this._focus()}_focus(){const e=this.links[0];e&&(e.focus(),this.request(this.verify.bind(this)))}verify(){if(this.count++,this.count>100)return;const e=this.links[0];e&&document.activeElement!==e&&this._focus()}}const Oe={BREADCRUMB:Se.internals.ns.selector("breadcrumb")};Se.breadcrumb={BreadcrumbSelector:Oe,Breadcrumb:Ie},Se.internals.register(Se.breadcrumb.BreadcrumbSelector.BREADCRUMB,Se.breadcrumb.Breadcrumb);class De extends Se.core.Instance{static get instanceClassName(){return"ToggleInput"}get isChecked(){return this.node.checked}}class Me extends Se.core.Instance{static get instanceClassName(){return"ToggleStatusLabel"}init(){this.register(`input[id="${this.getAttribute("for")}"]`,De),this.update(),this.isSwappingFont=!0}get proxy(){return Object.assign(super.proxy,{update:this.update.bind(this)})}get input(){return this.getRegisteredInstances("ToggleInput")[0]}update(){this.node.style.removeProperty("--toggle-status-width");const e=this.input.isChecked,t=getComputedStyle(this.node,":before");let s=parseFloat(t.width);this.input.node.checked=!e;const i=getComputedStyle(this.node,":before"),n=parseFloat(i.width);n>s&&(s=n),this.input.node.checked=e,this.node.style.setProperty("--toggle-status-width",s/16+"rem")}swapFont(e){this.update()}}const ke={STATUS_LABEL:`${Se.internals.ns.selector("toggle__label")}${Se.internals.ns.attr.selector("checked-label")}${Se.internals.ns.attr.selector("unchecked-label")}`};Se.toggle={ToggleStatusLabel:Me,ToggleSelector:ke},Se.internals.register(Se.toggle.ToggleSelector.STATUS_LABEL,Se.toggle.ToggleStatusLabel);const Re={LIST:Se.internals.ns.selector("sidemenu__list"),COLLAPSE:`${Se.internals.ns.selector("sidemenu__item")} > ${Se.internals.ns.selector("collapse")}`};class Pe extends Se.core.CollapsesGroup{static get instanceClassName(){return"SidemenuList"}validate(e){return e.node.matches(Re.COLLAPSE)}}Se.sidemenu={SidemenuList:Pe,SidemenuSelector:Re},Se.internals.register(Se.sidemenu.SidemenuSelector.LIST,Se.sidemenu.SidemenuList);const He={MODAL:Se.internals.ns.selector("modal"),SCROLL_SHADOW:Se.internals.ns.selector("scroll-shadow"),BODY:Se.internals.ns.selector("modal__body")};class Ge extends Se.core.DisclosureButton{constructor(){super(Se.core.DisclosureType.OPENED)}static get instanceClassName(){return"ModalButton"}}const $e={CONCEALING_BACKDROP:Se.internals.ns.attr("concealing-backdrop")};class qe extends Se.core.Disclosure{constructor(){super(Se.core.DisclosureType.OPENED,He.MODAL,Ge,"ModalsGroup"),this.scrolling=this.resize.bind(this,!1),this.resizing=this.resize.bind(this,!0)}static get instanceClassName(){return"Modal"}init(){super.init(),this.listen("click",this.click.bind(this)),this.listenKey(Se.core.KeyCodes.ESCAPE,this.conceal.bind(this,!1,!1),!0,!0)}get body(){return this.element.getDescendantInstances("ModalBody","Modal")[0]}click(e){e.target===this.node&&"false"!==this.getAttribute($e.CONCEALING_BACKDROP)&&this.conceal()}disclose(e){return!!super.disclose(e)&&(this.body&&this.body.activate(),this.isScrollLocked=!0,this.setAttribute("aria-modal","true"),this.setAttribute("open","true"),!0)}conceal(e,t){return!!super.conceal(e,t)&&(this.isScrollLocked=!1,this.removeAttribute("aria-modal"),this.removeAttribute("open"),this.body&&this.body.deactivate(),!0)}}const Be=['[tabindex="0"]',"a[href]","button:not([disabled])","input:not([disabled])","select:not([disabled])","textarea:not([disabled])","audio[controls]","video[controls]",'[contenteditable]:not([contenteditable="false"])',"details>summary:first-of-type","details","iframe"].join(),Ue=['[tabindex]:not([tabindex="-1"]):not([tabindex="0"])'].join(),ze=(e,t)=>{if(!(e instanceof Element))return!1;const s=window.getComputedStyle(e);if(!s)return!1;if("hidden"===s.visibility)return!1;for(void 0===t&&(t=e);t.contains(e);){if("none"===s.display)return!1;e=e.parentElement}return!0};class Fe{constructor(e,t){this.element=null,this.activeElement=null,this.onTrap=e,this.onUntrap=t,this.waiting=this.wait.bind(this),this.handling=this.handle.bind(this),this.focusing=this.maintainFocus.bind(this),this.current=null}get trapped(){return null!==this.element}trap(e){this.trapped&&this.untrap(),this.element=e,this.isTrapping=!0,this.wait(),this.onTrap&&this.onTrap()}wait(){ze(this.element)?this.trapping():window.requestAnimationFrame(this.waiting)}trapping(){if(!this.isTrapping)return;this.isTrapping=!1;const e=this.focusables;e.length&&-1===e.indexOf(document.activeElement)&&e[0].focus(),this.element.setAttribute("aria-modal",!0),window.addEventListener("keydown",this.handling),document.body.addEventListener("focus",this.focusing,!0)}stun(e){for(const t of e.children)t!==this.element&&(t.contains(this.element)?this.stun(t):this.stunneds.push(new je(t)))}maintainFocus(e){if(!this.element.contains(e.target)){const t=this.focusables;if(0===t.length)return;const s=t[0];e.preventDefault(),s.focus()}}handle(e){if(9!==e.keyCode)return;const t=this.focusables;if(0===t.length)return;const s=t[0],i=t[t.length-1],n=t.indexOf(document.activeElement);e.shiftKey?!this.element.contains(document.activeElement)||n<1?(e.preventDefault(),i.focus()):(document.activeElement.tabIndex>0||t[n-1].tabIndex>0)&&(e.preventDefault(),t[n-1].focus()):this.element.contains(document.activeElement)&&n!==t.length-1&&-1!==n?document.activeElement.tabIndex>0&&(e.preventDefault(),t[n+1].focus()):(e.preventDefault(),s.focus())}get focusables(){let e=Se.internals.dom.querySelectorAllArray(this.element,Be);const t=Se.internals.dom.querySelectorAllArray(document.documentElement,'input[type="radio"]');if(t.length){const s={};for(const e of t){const t=e.getAttribute("name");void 0===s[t]&&(s[t]=new We(t)),s[t].push(e)}e=e.filter((e=>{if("input"!==e.tagName.toLowerCase()||"radio"!==e.getAttribute("type").toLowerCase())return!0;const t=e.getAttribute("name");return s[t].keep(e)}))}const s=Se.internals.dom.querySelectorAllArray(this.element,Ue);s.sort(((e,t)=>e.tabIndex-t.tabIndex));const i=e.filter((e=>-1===s.indexOf(e)));return s.concat(i).filter((e=>"-1"!==e.tabIndex&&ze(e,this.element)))}untrap(){this.trapped&&(this.isTrapping=!1,this.element.removeAttribute("aria-modal"),window.removeEventListener("keydown",this.handling),document.body.removeEventListener("focus",this.focusing,!0),this.element=null,this.onUntrap&&this.onUntrap())}dispose(){this.untrap()}}class je{constructor(e){this.element=e,this.inert=e.getAttribute("inert"),this.element.setAttribute("inert","")}unstun(){null===this.inert?this.element.removeAttribute("inert"):this.element.setAttribute("inert",this.inert)}}class We{constructor(e){this.name=e,this.buttons=[]}push(e){this.buttons.push(e),(e===document.activeElement||e.checked||void 0===this.selected)&&(this.selected=e)}keep(e){return this.selected===e}}class Ke extends Se.core.DisclosuresGroup{constructor(){super("Modal",!1),this.focusTrap=new Fe}static get instanceClassName(){return"ModalsGroup"}apply(e,t){super.apply(e,t),null===this.current?this.focusTrap.untrap():this.focusTrap.trap(this.current.node)}}class Ve extends Se.core.Instance{static get instanceClassName(){return"ModalBody"}init(){this.listen("scroll",this.shade.bind(this))}activate(){this.isResizing=!0,this.resize()}deactivate(){this.isResizing=!1}shade(){this.node.scrollHeight>this.node.clientHeight?this.node.offsetHeight+this.node.scrollTop>=this.node.scrollHeight?this.removeClass(He.SCROLL_SHADOW):this.addClass(He.SCROLL_SHADOW):this.removeClass(He.SCROLL_SHADOW)}resize(){this.adjust(),this.request(this.adjust.bind(this))}adjust(){const e=32*(this.isBreakpoint(Se.core.Breakpoints.MD)?2:1);this.isLegacy?this.style.maxHeight=window.innerHeight-e+"px":this.style.setProperty("--modal-max-height",window.innerHeight-e+"px"),this.shade()}}Se.modal={Modal:qe,ModalButton:Ge,ModalBody:Ve,ModalsGroup:Ke,ModalSelector:He},Se.internals.register(Se.modal.ModalSelector.MODAL,Se.modal.Modal),Se.internals.register(Se.modal.ModalSelector.BODY,Se.modal.ModalBody),Se.internals.register(Se.core.RootSelector.ROOT,Se.modal.ModalsGroup);const Ye={TOGGLE:Se.internals.ns.emission("password","toggle"),ADJUST:Se.internals.ns.emission("password","adjust")};class Qe extends Se.core.Instance{static get instanceClassName(){return"PasswordToggle"}init(){this.listen("click",this.toggle.bind(this)),this.ascend(Ye.ADJUST,this.width),this.isSwappingFont=!0,this._isChecked=this.isChecked}get width(){const e=getComputedStyle(this.node.parentNode);return parseInt(e.width)}get isChecked(){return this.node.checked}set isChecked(e){this._isChecked=e,this.ascend(Ye.TOGGLE,e)}toggle(){this.isChecked=!this._isChecked}swapFont(e){this.ascend(Ye.ADJUST,this.width)}}class Je extends Se.core.Instance{static get instanceClassName(){return"Password"}init(){this.addAscent(Ye.TOGGLE,this.toggle.bind(this)),this.addAscent(Ye.ADJUST,this.adjust.bind(this))}toggle(e){this.descend(Ye.TOGGLE,e)}adjust(e){this.descend(Ye.ADJUST,e)}}const Ze={PASSWORD:Se.internals.ns.selector("password"),INPUT:Se.internals.ns.selector("password__input"),LABEL:Se.internals.ns.selector("password__label"),TOOGLE:`${Se.internals.ns.selector("password__checkbox")} input[type="checkbox"]`};class Xe extends Se.core.Instance{static get instanceClassName(){return"PasswordInput"}init(){this.addDescent(Ye.TOGGLE,this.toggle.bind(this)),this._isRevealed="password"===this.hasAttribute("type"),this.listen("keydown",this.capslock.bind(this)),this.listen("keyup",this.capslock.bind(this))}toggle(e){this.isRevealed=e,this.setAttribute("type",e?"text":"password")}get isRevealed(){return this._isRevealed}capslock(e){e&&"function"!=typeof e.getModifierState||(e.getModifierState("CapsLock")?this.node.parentNode.setAttribute(Se.internals.ns.attr("capslock"),""):this.node.parentNode.removeAttribute(Se.internals.ns.attr("capslock")))}set isRevealed(e){this._isRevealed=e,this.setAttribute("type",e?"text":"password")}}class et extends Se.core.Instance{static get instanceClassName(){return"PasswordLabel"}init(){this.addDescent(Ye.ADJUST,this.adjust.bind(this))}adjust(e){const t=Math.ceil(e/16);this.node.style.paddingRight=t+"rem"}}Se.password={Password:Je,PasswordToggle:Qe,PasswordSelector:Ze,PasswordInput:Xe,PasswordLabel:et},Se.internals.register(Se.password.PasswordSelector.INPUT,Se.password.PasswordInput),Se.internals.register(Se.password.PasswordSelector.PASSWORD,Se.password.Password),Se.internals.register(Se.password.PasswordSelector.TOOGLE,Se.password.PasswordToggle),Se.internals.register(Se.password.PasswordSelector.LABEL,Se.password.PasswordLabel);const tt={NAVIGATION:Se.internals.ns.selector("nav"),COLLAPSE:`${Se.internals.ns.selector("nav__item")} > ${Se.internals.ns.selector("collapse")}`,ITEM:Se.internals.ns.selector("nav__item"),ITEM_RIGHT:Se.internals.ns("nav__item--align-right"),MENU:Se.internals.ns.selector("menu")};class st extends Se.core.Instance{constructor(){super(),this._isRightAligned=!1}static get instanceClassName(){return"NavigationItem"}init(){this.addAscent(Se.core.DisclosureEmission.ADDED,this.calculate.bind(this)),this.addAscent(Se.core.DisclosureEmission.REMOVED,this.calculate.bind(this)),this.isResizing=!0,this.calculate()}resize(){this.calculate()}calculate(){const e=this.element.getDescendantInstances(Se.core.Collapse.instanceClassName,null,!0)[0];if(e&&this.isBreakpoint(Se.core.Breakpoints.LG)&&e.element.node.matches(tt.MENU)){const t=this.element.node.parentElement.getBoundingClientRect().right,s=e.element.node.getBoundingClientRect().width,i=this.element.node.getBoundingClientRect().left;this.isRightAligned=i+s>t}else this.isRightAligned=!1}get isRightAligned(){return this._isRightAligned}set isRightAligned(e){this._isRightAligned!==e&&(this._isRightAligned=e,e?Se.internals.dom.addClass(this.element.node,tt.ITEM_RIGHT):Se.internals.dom.removeClass(this.element.node,tt.ITEM_RIGHT))}}const it={NONE:-1,INSIDE:0,OUTSIDE:1};class nt extends Se.core.CollapsesGroup{static get instanceClassName(){return"Navigation"}init(){super.init(),this.clicked=!1,this.out=!1,this.listen("focusout",this.focusOutHandler.bind(this)),this.listen("mousedown",this.mouseDownHandler.bind(this)),this.listen("click",this.clickHandler.bind(this),{capture:!0})}validate(e){return e.element.node.matches(tt.COLLAPSE)}mouseDownHandler(e){this.isBreakpoint(Se.core.Breakpoints.LG)&&-1!==this.index&&this.current&&(this.position=this.current.node.contains(e.target)?it.INSIDE:it.OUTSIDE,this.requestPosition())}clickHandler(e){!e.target.matches("a, button")||e.target.matches("[aria-controls]")||e.target.matches(Se.core.DisclosureSelector.PREVENT_CONCEAL)||(this.index=-1)}focusOutHandler(e){this.isBreakpoint(Se.core.Breakpoints.LG)&&(this.out=!0,this.requestPosition())}requestPosition(){this.isRequesting||(this.isRequesting=!0,this.request(this.getPosition.bind(this)))}getPosition(){if(this.out)switch(this.position){case it.OUTSIDE:this.index=-1;break;case it.INSIDE:this.current&&!this.current.node.contains(document.activeElement)&&this.current.focus();break;default:this.index>-1&&!this.current.hasFocus&&(this.index=-1)}this.request(this.requested.bind(this))}requested(){this.position=it.NONE,this.out=!1,this.isRequesting=!1}get index(){return super.index}set index(e){-1===e&&null!==this.current&&this.current.hasFocus&&this.current.focus(),super.index=e}}Se.navigation={Navigation:nt,NavigationItem:st,NavigationMousePosition:it,NavigationSelector:tt},Se.internals.register(Se.navigation.NavigationSelector.NAVIGATION,Se.navigation.Navigation),Se.internals.register(Se.navigation.NavigationSelector.ITEM,Se.navigation.NavigationItem);class rt extends Se.core.DisclosureButton{constructor(){super(Se.core.DisclosureType.SELECT)}static get instanceClassName(){return"TabButton"}apply(e){super.apply(e),this.isPrimary&&(this.setAttribute("tabindex",e?"0":"-1"),e&&this.list&&this.list.focalize(this))}get list(){return this.element.getAscendantInstance("TabsList","TabsGroup")}}const ot={TAB:Se.internals.ns.selector("tabs__tab"),GROUP:Se.internals.ns.selector("tabs"),PANEL:Se.internals.ns.selector("tabs__panel"),LIST:Se.internals.ns.selector("tabs__list"),SHADOW:Se.internals.ns.selector("tabs__shadow"),SHADOW_LEFT:Se.internals.ns.selector("tabs__shadow--left"),SHADOW_RIGHT:Se.internals.ns.selector("tabs__shadow--right"),PANEL_START:Se.internals.ns.selector("tabs__panel--direction-start"),PANEL_END:Se.internals.ns.selector("tabs__panel--direction-end")},at="direction-start",ct="direction-end",ht="none";class lt extends Se.core.Disclosure{constructor(){super(Se.core.DisclosureType.SELECT,ot.PANEL,rt,"TabsGroup"),this._direction=ht,this._isPreventingTransition=!1}static get instanceClassName(){return"TabPanel"}get direction(){return this._direction}set direction(e){if(e!==this._direction){switch(this._direction){case at:this.removeClass(ot.PANEL_START);break;case ct:this.removeClass(ot.PANEL_END);break;case ht:break;default:return}switch(this._direction=e,this._direction){case at:this.addClass(ot.PANEL_START);break;case ct:this.addClass(ot.PANEL_END)}}}get isPreventingTransition(){return this._isPreventingTransition}set isPreventingTransition(e){this._isPreventingTransition!==e&&(e?this.addClass(Se.internals.motion.TransitionSelector.NONE):this.removeClass(Se.internals.motion.TransitionSelector.NONE),this._isPreventingTransition=!0===e)}translate(e,t){this.isPreventingTransition=t,this.direction=e}reset(){this.group.index=0}}class dt extends Se.core.DisclosuresGroup{constructor(){super("TabPanel")}static get instanceClassName(){return"TabsGroup"}init(){super.init(),this.listen("transitionend",this.transitionend.bind(this)),this.listenKey(Se.core.KeyCodes.RIGHT,this.pressRight.bind(this),!0,!0),this.listenKey(Se.core.KeyCodes.LEFT,this.pressLeft.bind(this),!0,!0),this.listenKey(Se.core.KeyCodes.HOME,this.pressHome.bind(this),!0,!0),this.listenKey(Se.core.KeyCodes.END,this.pressEnd.bind(this),!0,!0),this.isRendering=!0,this.list&&this.list.apply()}get list(){return this.element.getDescendantInstances("TabsList","TabsGroup",!0)[0]}transitionend(e){this.isPreventingTransition=!0}get buttonHasFocus(){return this.members.some((e=>e.buttonHasFocus))}pressRight(){this.buttonHasFocus&&(this.index<this.length-1?this.index++:this.index=0,this.focus())}pressLeft(){this.buttonHasFocus&&(this.index>0?this.index--:this.index=this.length-1,this.focus())}pressHome(){this.buttonHasFocus&&(this.index=0,this.focus())}pressEnd(){this.buttonHasFocus&&(this.index=this.length-1,this.focus())}focus(){this.current&&this.current.focus()}apply(){for(let e=0;e<this._index;e++)this.members[e].translate(at);this.current.translate(ht);for(let e=this._index+1;e<this.length;e++)this.members[e].translate(ct);this.isPreventingTransition=!1}get isPreventingTransition(){return this._isPreventingTransition}set isPreventingTransition(e){this._isPreventingTransition!==e&&(e?this.addClass(Se.internals.motion.TransitionSelector.NONE):this.removeClass(Se.internals.motion.TransitionSelector.NONE),this._isPreventingTransition=!0===e)}render(){if(null===this.current)return;const e=Math.round(this.current.node.offsetHeight);if(this.panelHeight===e)return;this.panelHeight=e;let t=0;this.list&&(t=this.list.node.offsetHeight),this.style.setProperty("--tabs-height",this.panelHeight+t+"px")}}class ut extends Se.core.Instance{static get instanceClassName(){return"TabsList"}init(){this.listen("scroll",this.scroll.bind(this)),this.isResizing=!0}get group(){return this.element.getAscendantInstance("TabsGroup","TabsList")}focalize(e){const t=e.getRect(),s=this.getRect(),i=this.node.scrollLeft;t.left<s.left?this.node.scrollTo(i-s.left+t.left-16,0):t.right>s.right&&this.node.scrollTo(i-s.right+t.right+16,0)}get isScrolling(){return this._isScrolling}set isScrolling(e){this._isScrolling!==e&&(this._isScrolling=e,this.apply())}apply(){this.group&&(this._isScrolling?(this.group.addClass(ot.SHADOW),this.scroll()):(this.group.removeClass(ot.SHADOW_RIGHT),this.group.removeClass(ot.SHADOW_LEFT),this.group.removeClass(ot.SHADOW)))}scroll(){if(!this.group)return;const e=this.node.scrollLeft,t=e<=16,s=this.node.scrollWidth-this.node.clientWidth-16,i=Math.abs(e)>=s,n="rtl"===document.documentElement.getAttribute("dir"),r=n?ot.SHADOW_RIGHT:ot.SHADOW_LEFT,o=n?ot.SHADOW_LEFT:ot.SHADOW_RIGHT;t?this.group.removeClass(r):this.group.addClass(r),i?this.group.removeClass(o):this.group.addClass(o)}resize(){this.isScrolling=this.node.scrollWidth>this.node.clientWidth+16,this.setProperty("--tab-list-height",`${this.getRect().height}px`)}dispose(){this.isScrolling=!1}}Se.tab={TabPanel:lt,TabButton:rt,TabsGroup:dt,TabsList:ut,TabSelector:ot},Se.internals.register(Se.tab.TabSelector.PANEL,Se.tab.TabPanel),Se.internals.register(Se.tab.TabSelector.GROUP,Se.tab.TabsGroup),Se.internals.register(Se.tab.TabSelector.LIST,Se.tab.TabsList);const gt={SCROLLABLE:Se.internals.ns.emission("table","scrollable"),CHANGE:Se.internals.ns.emission("table","change"),CAPTION_HEIGHT:Se.internals.ns.emission("table","captionheight")};class pt extends Se.core.Instance{static get instanceClassName(){return"Table"}init(){this.addAscent(gt.CAPTION_HEIGHT,this.setCaptionHeight.bind(this))}setCaptionHeight(e){this.setProperty("--table-offset",`calc(${e}px + 1rem)`)}}const mt={TABLE:Se.internals.ns.selector("table"),SHADOW:Se.internals.ns.selector("table__shadow"),SHADOW_LEFT:Se.internals.ns.selector("table__shadow--left"),SHADOW_RIGHT:Se.internals.ns.selector("table__shadow--right"),ELEMENT:`${Se.internals.ns.selector("table")}:not(${Se.internals.ns.selector("table--no-scroll")}) table`,CAPTION:`${Se.internals.ns.selector("table")} table caption`};class bt extends Se.core.Instance{static get instanceClassName(){return"TableElement"}init(){this.listen("scroll",this.scroll.bind(this)),this.content=this.querySelector("tbody"),this.isResizing=!0}get isScrolling(){return this._isScrolling}set isScrolling(e){this._isScrolling!==e&&(this._isScrolling=e,e?(this.addClass(mt.SHADOW),this.scroll()):(this.removeClass(mt.SHADOW),this.removeClass(mt.SHADOW_LEFT),this.removeClass(mt.SHADOW_RIGHT)))}scroll(){const e=this.node.scrollLeft<=8,t=this.content.offsetWidth-this.node.offsetWidth-8,s=Math.abs(this.node.scrollLeft)>=t,i="rtl"===document.documentElement.getAttribute("dir"),n=i?mt.SHADOW_RIGHT:mt.SHADOW_LEFT,r=i?mt.SHADOW_LEFT:mt.SHADOW_RIGHT;e?this.removeClass(n):this.addClass(n),s?this.removeClass(r):this.addClass(r)}resize(){this.isScrolling=this.content.offsetWidth>this.node.offsetWidth}dispose(){this.isScrolling=!1}}class ft extends Se.core.Instance{static get instanceClassName(){return"TableCaption"}init(){this.height=0,this.isResizing=!0}resize(){const e=this.getRect().height;this.height!==e&&(this.height=e,this.ascend(gt.CAPTION_HEIGHT,e))}}Se.table={Table:pt,TableElement:bt,TableCaption:ft,TableSelector:mt},Se.internals.register(Se.table.TableSelector.TABLE,Se.table.Table),Se.internals.register(Se.table.TableSelector.ELEMENT,Se.table.TableElement),Se.internals.register(Se.table.TableSelector.CAPTION,Se.table.TableCaption);const _t={DISMISS:Se.internals.ns.event("dismiss")};class St extends Se.core.Instance{static get instanceClassName(){return"TagDismissible"}init(){this.listen("click",this.click.bind(this))}click(){switch(this.focusClosest(),Se.mode){case Se.Modes.ANGULAR:case Se.Modes.REACT:case Se.Modes.VUE:this.request(this.verify.bind(this));break;default:this.remove()}this.dispatch(_t.DISMISS)}verify(){document.body.contains(this.node)&&Se.inspector.warn(`a TagDismissible has just been dismissed and should be removed from the dom. In ${Se.mode} mode, the api doesn't handle dom modification. An event ${_t.DISMISS} is dispatched by the element to trigger the removal`)}}const Et={PRESSABLE:`${Se.internals.ns.selector("tag")}[aria-pressed]`,DISMISSIBLE:`${Se.internals.ns.selector("tag--dismiss")}`};Se.tag={TagDismissible:St,TagSelector:Et,TagEvent:_t},Se.internals.register(Se.tag.TagSelector.PRESSABLE,Se.core.Toggle),Se.internals.register(Se.tag.TagSelector.DISMISSIBLE,Se.tag.TagDismissible);const yt={DOWNLOAD_ASSESS_FILE:`${Se.internals.ns.attr.selector("assess-file")}`,DOWNLOAD_DETAIL:`${Se.internals.ns.selector("download__detail")}`};class vt extends Se.core.Instance{static get instanceClassName(){return"AssessFile"}init(){this.lang=this.getLang(this.node),this.href=this.getAttribute("href"),this.hreflang=this.getAttribute("hreflang"),this.file={},this.detail=this.querySelector(yt.DOWNLOAD_DETAIL),this.update()}getFileLength(){void 0!==this.href?fetch(this.href,{method:"HEAD",mode:"cors"}).then((e=>{this.length=e.headers.get("content-length")||-1,-1===this.length&&Se.inspector.warn("File size unknown: "+this.href+'\nUnable to get HTTP header: "content-length"'),this.update()})):this.length=-1}update(){if(this.isLegacy&&(this.length=-1),!this.length)return void this.getFileLength();const e=[];if(this.detail){if(this.href){const t=this.parseExtension(this.href);t&&e.push(t.toUpperCase())}-1!==this.length&&e.push(this.bytesToSize(this.length)),this.hreflang&&e.push(this.getLangDisplayName(this.hreflang)),this.detail.innerHTML=e.join(" - ")}}getLang(e){return e.lang?e.lang:document.documentElement===e?window.navigator.language:this.getLang(e.parentElement)}parseExtension(e){return e.match(/\.(\w{1,9})(?:$|[?#])/)[0].replace(".","")}getLangDisplayName(e){if(this.isLegacy)return e;const t=new Intl.DisplayNames([this.lang],{type:"language"}).of(e);return t.charAt(0).toUpperCase()+t.slice(1)}bytesToSize(e){if(-1===e)return null;let t=["octets","ko","Mo","Go","To"];"bytes"===this.getAttribute(Se.internals.ns.attr("assess-file"))&&(t=["bytes","KB","MB","GB","TB"]);const s=parseInt(Math.floor(Math.log(e)/Math.log(1e3)),10);if(0===s)return`${e} ${t[s]}`;const i=e/1e3**s,n=Math.round(100*(i+Number.EPSILON))/100;return`${String(n).replace(".",",")} ${t[s]}`}}Se.download={DownloadSelector:yt,AssessFile:vt},Se.internals.register(Se.download.DownloadSelector.DOWNLOAD_ASSESS_FILE,Se.download.AssessFile);const At={HEADER:Se.internals.ns.selector("header"),TOOLS_LINKS:Se.internals.ns.selector("header__tools-links"),MENU_LINKS:Se.internals.ns.selector("header__menu-links"),BUTTONS:`${Se.internals.ns.selector("header__tools-links")} ${Se.internals.ns.selector("btns-group")}, ${Se.internals.ns.selector("header__tools-links")} ${Se.internals.ns.selector("links-group")}`,MODALS:`${Se.internals.ns.selector("header__search")}${Se.internals.ns.selector("modal")}, ${Se.internals.ns.selector("header__menu")}${Se.internals.ns.selector("modal")}`};class Ct extends Se.core.Instance{static get instanceClassName(){return"HeaderLinks"}init(){const e=this.queryParentSelector(At.HEADER);this.toolsLinks=e.querySelector(At.TOOLS_LINKS),this.menuLinks=e.querySelector(At.MENU_LINKS);const t=this.toolsLinks.innerHTML.replace(/  +/g," "),s=this.menuLinks.innerHTML.replace(/  +/g," ");let i=t.replace(/(<nav[.\s\S]*-translate [.\s\S]*) id="(.*?)"([.\s\S]*<\/nav>)/gm,'$1 id="$2-mobile"$3');if(i=i.replace(/(<nav[.\s\S]*-translate [.\s\S]*) aria-controls="(.*?)"([.\s\S]*<\/nav>)/gm,'$1 aria-controls="$2-mobile"$3'),i!==s)switch(Se.mode){case Se.Modes.ANGULAR:case Se.Modes.REACT:case Se.Modes.VUE:Se.inspector.warn(`header__tools-links content is different from header__menu-links content.\nAs you're using a dynamic framework, you should handle duplication of this content yourself, please refer to documentation:\n${Se.header.doc}`);break;default:this.menuLinks.innerHTML=i}}}class Tt extends Se.core.Instance{constructor(){super(),this._clickHandling=this.clickHandler.bind(this)}static get instanceClassName(){return"HeaderModal"}init(){this.isResizing=!0}resize(){this.isBreakpoint(Se.core.Breakpoints.LG)?this.unqualify():this.qualify()}qualify(){this.setAttribute("role","dialog");const e=this.element.getInstance("Modal");if(!e)return;const t=e.buttons;let s="";for(const e of t)if(s=e.id||s,e.isPrimary&&s)break;this.setAttribute("aria-labelledby",s),this.listen("click",this._clickHandling,{capture:!0})}unqualify(){const e=this.element.getInstance("Modal");e&&e.conceal(),this.removeAttribute("role"),this.removeAttribute("aria-labelledby"),this.unlisten("click",this._clickHandling,{capture:!0})}clickHandler(e){if(e.target.matches("a, button")&&!e.target.matches("[aria-controls]")&&!e.target.matches(Se.core.DisclosureSelector.PREVENT_CONCEAL)){this.element.getInstance("Modal").conceal()}}}Se.header={HeaderLinks:Ct,HeaderModal:Tt,HeaderSelector:At,doc:"https://www.systeme-de-design.gouv.fr/elements-d-interface/composants/en-tete"},Se.internals.register(Se.header.HeaderSelector.TOOLS_LINKS,Se.header.HeaderLinks),Se.internals.register(Se.header.HeaderSelector.MODALS,Se.header.HeaderModal);const Lt={DISPLAY:Se.internals.ns.selector("display"),RADIO_BUTTONS:`input[name="${Se.internals.ns("radios-theme")}"]`,FIELDSET:Se.internals.ns.selector("fieldset")};class Nt extends Se.core.Instance{static get instanceClassName(){return"Display"}init(){if(this.radios=this.querySelectorAll(Lt.RADIO_BUTTONS),Se.scheme){this.changing=this.change.bind(this);for(const e of this.radios)e.addEventListener("change",this.changing);this.addDescent(Se.scheme.SchemeEmission.SCHEME,this.apply.bind(this)),this.ascend(Se.scheme.SchemeEmission.ASK)}else this.querySelector(Lt.FIELDSET).setAttribute("disabled","")}get scheme(){return this._scheme}set scheme(e){if(this._scheme!==e&&Se.scheme)switch(e){case Se.scheme.SchemeValue.SYSTEM:case Se.scheme.SchemeValue.LIGHT:case Se.scheme.SchemeValue.DARK:this._scheme=e;for(const t of this.radios)t.checked=t.value===e;this.ascend(Se.scheme.SchemeEmission.SCHEME,e)}}change(){for(const e of this.radios)if(e.checked)return void(this.scheme=e.value)}apply(e){this.scheme=e}dispose(){for(const e of this.radios)e.removeEventListener("change",this.changing)}}Se.display={Display:Nt,DisplaySelector:Lt},Se.internals.register(Se.display.DisplaySelector.DISPLAY,Se.display.Display);
